<?php
namespace Neuron\Person\Controller;

use Neuron\Person\Attribute as EmpAttributeModel;

class Detail extends \Neuron\Person\Controller {
  	
	public function loadAction() {
		$storage = \Neuron\Person\Detail\Storage::factory($this->getDb(), $this->getConfig());
		$cdet = new \Neuron\Person\Detail($storage);

		$libs['Contact'] = class_exists('Neuron\Contact\Controller\Contact');
		$libs['Organization'] = class_exists('Neuron\Organization\Controller\Organization');
		$libs['Payroll'] = class_exists('Neuron\Payroll\Controller\Payroll');

		$post = $this->getPostParams();
		if (!$cdet->load($post['person_id'],\Neuron\Person\Detail\Storage::LOADBY_PERSON))  {
			echo json_encode(array('success' => false, 'data' => array(), 'libs' => $libs));
			return $this->getResponse();
		}


		$detaildata = $cdet->pull();
		return $this->getOutput(json_encode(array('success' => true, 'data' => $detaildata, 'libs' => $libs)));
		// echo json_encode(array('success' => true, 'data' => $detaildata, 'libs' => $libs));
		// return $this->getResponse();
	}

	public function saveAction() {
		$storage = \Neuron\Person\Detail\Storage::factory($this->getDb(), $this->getConfig());
		
		$cdet = new \Neuron\Person\Detail($storage);
		
		$post = $this->getPostParams();

		// Upload signature
		if ( isset($_FILES["pic_signature"]["type"]) && !empty($_FILES["pic_signature"]["type"]) ) {
			$uploaded = $this->uploadFile($_FILES["pic_signature"], $upfile, $post['person_id'], true);
			if ($uploaded != 'OK') {
				echo json_encode(array('success' => false, 'msg' => $uploaded));
				return $this->getResponse();
			}
			$post['pic_signature'] = $upfile;
		}

		$update = false;
		
		if (!empty($post['detail_id'])) {
			$update = true;
			$cdet->load($post['person_id'], \Neuron\Person\Detail\Storage::LOADBY_PERSON);
			// Upload pic official

			if(isset($_FILES["pic_official"]) && $_FILES["pic_official"]['error'] == 0) {
				if(isset($cdet->pic_official)) {
					unlink(getcwd() . '/public' . $cdet->pic_official);
				}

				if ( isset($_FILES["pic_official"]) && !empty($_FILES["pic_official"]) ) {
					$uploaded = $this->uploadFile($_FILES["pic_official"], $upfile, $post['person_id']);
					if ($uploaded != 'OK') {
						echo json_encode(array('success' => false, 'msg' => $uploaded));
						return $this->getResponse();
					}
					
					$post['pic_official'] = $upfile;
					$uploadUrl = $upfile;
				}
			}else if(isset($post['pic_official'])) {
				// delete dulu file lama nya
				if(isset($cdet->pic_official)) {
					unlink(getcwd() . '/public' . $cdet->pic_official);
				}
	
				// simpan file yang barunya
				$data = $post['pic_official'];
	
				list($type, $data) = explode(';', $data);
				list(, $data)      = explode(',', $data);
				$data = base64_decode($data);

				$uploadPath = getcwd() . '/public/userfiles/person';
				$uploadedFile = $uploadPath.'/'.$post['person_id'].'.jpeg';
				$uploadUrl = '/userfiles/person/'.$post['person_id'].'.jpeg';

				if(!file_exists($uploadPath)){
                    if(!@mkdir($uploadPath, 0755, true)){
						echo json_encode(array('success' => false, 'msg' => "Failed creating directory"));
						return $this->getResponse();

					}
                }
				file_put_contents($uploadedFile, $data);
			}

			// Upload signature
			if(isset($_FILES["pic_signature"]) && $_FILES["pic_signature"]['error'] == 0) {
				if(isset($cdet->pic_signature)) {
					unlink(getcwd() . '/public' . $cdet->pic_signature);
				}

				if ( isset($_FILES["pic_signature"]["type"]) && !empty($_FILES["pic_signature"]["type"]) ) {
					$uploaded = $this->uploadFile($_FILES["pic_signature"], $upfile, $post['person_id'], true);
					if ($uploaded != 'OK') {
						echo json_encode(array('success' => false, 'msg' => $uploaded));
						return $this->getResponse();
					}
					
					$post['pic_signature'] = $upfile;
				}
			}

			$post['about'] = (!isset($post['about']) && $post['about'] =='')? $cdet->about : $post['about'];
			$post['join_date'] = (!isset($post['join_date']) && $post['join_date'] =='')? $cdet->join_date : date('Y-m-d', strtotime($post['join_date']));
			$post['termination_date'] = (!isset($post['termination_date']) && $post['termination_date'] =='')? $cdet->termination_date : date('Y-m-d', strtotime($post['termination_date']));
			// $post['tax_id'] = (!isset($post['tax_id']) && $post['tax_id'] =='')? $cdet->tax_id : $post['tax_id'];
			$post['pic_official'] = (!isset($post['pic_official']) && $post['pic_official'] =='')? $cdet->pic_official : $uploadUrl;
			$post['pic_signature'] = (!isset($post['pic_signature']) && $post['pic_signature'] =='')? $cdet->pic_signature : $post['pic_signature'];

			$post['flag_geolocation'] = isset($post['flag_geolocation']) ? $post['flag_geolocation'] : $cdet->flag_geolocation;
			$post['flag_attd_evidence'] = isset($post['flag_attd_evidence']) ? $post['flag_attd_evidence'] : $cdet->flag_attd_evidence;
			$post['flag_timetable_overlap'] = isset($post['flag_timetable_overlap']) ? $post['flag_timetable_overlap'] : $cdet->flag_timetable_overlap;
		}else{
			$post['detail_id'] = null;
			$post['flag_geolocation'] = isset($post['flag_geolocation']) ? $post['flag_geolocation'] : 0;
			$post['flag_attd_evidence'] = isset($post['flag_attd_evidence']) ? $post['flag_attd_evidence'] : 0;
			$post['flag_timetable_overlap'] = isset($post['flag_timetable_overlap']) ? $post['flag_timetable_overlap'] : 0;
		}

		$post['termination_date'] = ($post['termination_date'] =='')? null: date('Y-m-d', strtotime($post['termination_date']));
		$cdetnew = new \Neuron\Person\Detail($storage, $post);
		
		if($update){
			$cdetnew->load($post['detail_id'], \Neuron\Person\Detail\Storage::LOADBY_ID);
			$dataCdet = $cdetnew->pull();
			foreach ($post as $key => $value) {
				if(array_key_exists($key, $dataCdet)){
					$dataCdet[$key] = $post[$key];
				}
			}

			$cdetnew->push($dataCdet);
		}
		
		$cdetnew = new \Neuron\Person\Detail($storage, $post);
		$retval = $cdetnew->save($update);

		echo json_encode(array('success' => $retval));
		
		$requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $post
		); 

		$logparam['subject'] = 'PERSON SAVE DETAIL';
		$logparam['identity'] = $this->getSession()->owner();;
		$logparam['data1'] = $retval;
		$logparam['description'] = 'Log proses person save detail';
		$logparam['request'] = json_encode($requestPost);
		$logparam['response'] = json_encode($retval);

		$this->writeLogAction($logparam);
		
		return $this->getResponse();
	}

	private function uploadFile($files, &$upfile, $employee_id = 0, $signature = false) {
		$name     = $files['name'];
		$tmpName  = $files['tmp_name'];
		$error    = $files['error'];
		$size     = $files['size'];
		$ext      = strtolower(pathinfo($name, PATHINFO_EXTENSION));

		switch ($error) {
			case UPLOAD_ERR_OK:
					$valid = true;
					//validate file extensions
					if ( !in_array($ext, array('jpg','jpeg','png','gif')) ) {
							$valid = false;
							$response = 'Invalid file extension.';
					}
					//validate file size
					if ( $size/1024/1024 > 2 ) {
							$valid = false;
							$response = 'File size is exceeding maximum allowed size.';
					}
					//upload file
					if ($valid) {
						if($signature){
							$uploadPath = getcwd() . '/public/userfiles/signature';
							$targetPath = getcwd() . '/public/userfiles/signature/' . $employee_id.'.'.$ext;
						}else{
							$uploadPath = getcwd() . '/public/userfiles/person';
							$targetPath = getcwd() . '/public/userfiles/person/' . $employee_id.'.'.$ext;
						}
						
						if(!file_exists($uploadPath)){
							mkdir($uploadPath,0777,true);
						}

						move_uploaded_file($tmpName, $targetPath);
						if($signature){
							$upfile = '/userfiles/signature/' . $employee_id.'.'.$ext;
						}else{
							$upfile = '/userfiles/person/' . $employee_id.'.'.$ext;
						}
						$response = 'OK';
					}
					break;
			case UPLOAD_ERR_INI_SIZE:
					$response = 'The uploaded file exceeds the upload_max_filesize directive in php.ini.';
					break;
			case UPLOAD_ERR_FORM_SIZE:
					$response = 'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form.';
					break;
			case UPLOAD_ERR_PARTIAL:
					$response = 'The uploaded file was only partially uploaded.';
					break;
			case UPLOAD_ERR_NO_FILE:
					$response = 'No file was uploaded.';
					break;
			case UPLOAD_ERR_NO_TMP_DIR:
					$response = 'Missing a temporary folder. Introduced in PHP 4.3.10 and PHP 5.0.3.';
					break;
			case UPLOAD_ERR_CANT_WRITE:
					$response = 'Failed to write file to disk. Introduced in PHP 5.1.0.';
					break;
			case UPLOAD_ERR_EXTENSION:
					$response = 'File upload stopped by extension. Introduced in PHP 5.2.0.';
					break;
			default:
					$response = 'Unknown error';
			break;
		}

			return $response;
	}

	public function deleteAction() {
		$storage = \Neuron\Person\Detail\Storage::factory($this->getDb(), $this->getConfig());
		$cdet = new \Neuron\Person\Detail($storage);

		$post = $this->getPostParams();

		$retval = $cdet->delete($post['detail_id']);
		$success = false;
		if ($retval) $success = true;

		echo json_encode(array('success' => $success));
		
		$requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $post
		); 

		$logparam['subject'] = 'PERSON DELETE DETAIL';
		$logparam['identity'] = $this->getSession()->owner();;
		$logparam['data1'] = $retval;
		$logparam['description'] = 'Log proses person biodata';
		$logparam['request'] = json_encode($requestPost);
		$logparam['response'] = json_encode($retval);

		$this->writeLogAction($logparam);
		
		return $this->getResponse();
	}

	public function personDetailAction() {
        $result = new \Neuron\Generic\Result();
        try {
        	$storageEmp = \Neuron\Person\Entity\Storage::factory($this->getDb(), $this->getConfig());
    		$cemp = new \Neuron\Person\Entity($storageEmp);

            $data = $this->getREST()->getParameters();
           if(!array_key_exists('ref_id', $data)){
                $result->code = 20;
                $result->info = 'invalid_request_parameter';
                return $this->getREST()->getResponse($result);
            }
            if (!isset($data['ref_id']) || $data['ref_id']=='') {
                $result->code = 10;
                $result->info = 'person id null';
                return $this->getREST()->getResponse($result);
            }
            $empId = $data['ref_id'];
		    $dataEmp = $cemp->detailPer($empId);

			if (class_exists("\Neuron\Addon\Person\ListAttribute\MappingAttribute")) {
                $employeeId = $empId;
                $storageAttribute   = EmpAttributeModel\Storage::factory($this->getDb(), $this->getConfig());
                $clsAttribute       = new EmpAttributeModel($storageAttribute);
                $resultAttribute    = $clsAttribute->loadList($employeeId);

                if (count($resultAttribute->data) > 0) {
                    foreach ($resultAttribute->data as $valAttribute) {
                        $keyName = strtolower($valAttribute['attr_code']);
                        $dataEmp['data'][$keyName] = $valAttribute['attr_value'];
                    }
                }
			}

            $result->guid = $dataEmp['guid'];
            $result->code = $dataEmp['code'];
            $result->info = $dataEmp['info'];
            $result->data = $dataEmp['data'];

            return $this->getREST()->getResponse($result);
        } catch (\Exception $ex) {
            $result->code = 100;
            $result->info = 'error';
            $result->data = array(
                'message' => $ex->getMessage(),
            );
            return $this->getREST()->getResponse($result);
        }
	}
	
	public function toggleGeolocationAction(){
		$post 			= $this->getREST()->getParameters();
		$detail 		= new \Neuron\Person\Detail(
			\Neuron\Person\Detail\Storage::factory($this->getDb(),$this->getConfig())
		);
		$result 		= $detail->toggleGeolocation($post);
		$result->info   = $this->translate($result->info);
		return $this->getREST()->getResponse($result);
	}
	
	public function toggleAttdEvidenceAction(){
		$post 			= $this->getREST()->getParameters();
		$detail 		= new \Neuron\Person\Detail(
			\Neuron\Person\Detail\Storage::factory($this->getDb(),$this->getConfig())
		);
		$result 		= $detail->toggleAttdEvidence($post);
		$result->info   = $this->translate($result->info);
		return $this->getREST()->getResponse($result);
	}
	
	public function toggleBpjsKsAction(){
		$post 			= $this->getREST()->getParameters();
		$detail 		= new \Neuron\Person\Detail(
			\Neuron\Person\Detail\Storage::factory($this->getDb(),$this->getConfig())
		);
		$result 		= $detail->toggleBpjsKs($post);
		$result->info   = $this->translate($result->info);
		return $this->getREST()->getResponse($result);
	}
	
	public function toggleBpjsKtAction(){
		$post 			= $this->getREST()->getParameters();
		$detail 		= new \Neuron\Person\Detail(
			\Neuron\Person\Detail\Storage::factory($this->getDb(),$this->getConfig())
		);
		$result 		= $detail->toggleBpjsKt($post);
		$result->info   = $this->translate($result->info);
		return $this->getREST()->getResponse($result);
	}

}
