<?php
namespace Neuron\Person;

use Neuron\Generic\Entity\Map;

class Family extends \Neuron\Generic\Entity\Mapper {
    
    protected $_storage;

    public function __construct(\Neuron\Person\Family\Storage\Skeleton $storage, $data = array()) {

        $this->_storage = $storage;

        parent::__construct(
            $data, 
            array(
                new Map('family_id'),
                new Map('person_id'),
                new Map('full_name'),
                new Map('identity_number'),
                new Map('gender'),
                new Map('birth_place'),
                new Map('birth_date'),
                new Map('education'),
                new Map('occupation'),
                new Map('marital_status'),
                new Map('family_position'),
                new Map('start_date'),
                new Map('end_date')
            ), 
            parent::CASE_INSENSITIVE
        );
    }
	
    public function load($id) {
      if ($data = $this->_storage->load($id)) {
        $this->push($data);
        return true;
      }
      return false;
    }

    public function save($update = false){
      if ($id = $this->_storage->save($this, $update)) {
        $this->family_id = $id;
        return true;
      }
      return false;
    }

    public function delete($id) {
        return $this->_storage->remove($id);
    }
    
}